#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"

TEST_CASE("distinct positive numbers") {
    double min = 0;
    double max = 0;
    find_minmax({1, 2}, min, max);
    CHECK(min == 1);
    CHECK(max == 2);
}
TEST_CASE("distinct negative numbers"){
    double min = 0;
    double max = 0;
    find_minmax({-1, -2}, min, max);
    CHECK(min == -2);
    CHECK(max == -1);
}
TEST_CASE("vector of the same elements"){
    double min = 0;
    double max = 0;
    find_minmax({3,3,3}, min, max);
    CHECK(min == 3);
    CHECK(max == 3);
}
TEST_CASE("vector of one elements"){
    double min = 0;
    double max = 0;
    find_minmax({3}, min, max);
    CHECK(min == max);
}
TEST_CASE("mixed positive and negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-1, 2, 0, -3, 5}, min, max);
    CHECK(min == -3);
    CHECK(max == 5);
}

TEST_CASE("vector with all negative numbers") {
    double min = 0;
    double max = 0;
    find_minmax({-5, -10, -2}, min, max);
    CHECK(min == -10);
    CHECK(max == -2);
}

TEST_CASE("vector with zero") {
    double min = 0;
    double max = 0;
    find_minmax({0, -1, 1}, min, max);
    CHECK(min == -1);
    CHECK(max == 1);
}

